/*
 * test2_MPU6050
 * Robot prints out angles estimated from MPU6050 using OSEPP code.
 * 
 * Need to have "I2C dev" folder in Arduino libraries
 * Need to have "MPU6050" folder in Arduino libraries
 *
 */

// #include "I2Cdev.h"
#include "MPU6050_6Axis_MotionApps20.h"

bool updateIMU();

extern MPU6050 mpu;
extern Quaternion q;           // [w, x, y, z]         quaternion container
extern VectorFloat gravity;    // [x, y, z]            gravity vector
extern float ypr[3];           // [yaw, pitch, roll]   yaw/pitch/roll container
extern float angle;

void setup()
{
  Wire.begin();
  Serial.begin(115200);
  while( !Serial );
  Serial.println( "test2_MPU6050 version 20" );
  Serial.println( "IMU angle test" );
  delay(1000); // take time to allow above messages to print.
  updateIMU();
  Serial.println( "Initialized ..." );
  delay(1000); // take time to allow above messages to print.
}

int count = 0;

void loop()
{
  if( !updateIMU() )
    return;
  Serial.print( count++ );
  Serial.print( " angle:\t" );
  Serial.print( angle );
  Serial.print( "\t ypr: \t" );
  Serial.print( ypr[0] ); Serial.print( "\t" );
  Serial.print( ypr[1] ); Serial.print( "\t" );
  Serial.print( ypr[2] ); Serial.print( "\t" );
  Serial.println();
  for ( int i = 0; i < 10; i++ )
    {
      updateIMU();
      delay( 5 );
    }
}
