/*
This program does something with the orange LED on the Every Nano board when
the button is pressed.

Copyright (c) 2014-2015 NicoHood
See the readme for credit to other people.

Connect a button/cable to pin 10 and ground.
The Led state will change if the pin state xque re
blindoes.

Use normal interrupts on the Nano Every board.
Dont use Serial or delay inside interrupts!
This library is not compatible with SoftSerial.
*/


#define Button_pin 10

void setup()
{
  // set pin to input with a pullup, led to output
  pinMode( Button_pin, INPUT_PULLUP );
  pinMode( LED_BUILTIN, OUTPUT );

  Serial.begin(115200);
  delay( 1000 );
  Serial.println( "Testing the button. Button press turns LED on Nano on." );
  Serial.println( "Still having trouble with debouncing and false alarms." );
  // Sometimes a RISING causes a FALLING trigger, and vice versa


  attachInterrupt( digitalPinToInterrupt(Button_pin), Button_isr, FALLING );
  // CHANGE = RISING or FALLING
}

volatile bool pressed = false;

void Button_isr(void)
{
  // Switch Led state
  digitalWrite( LED_BUILTIN, !digitalRead(LED_BUILTIN) );
  pressed = true;
}

void loop()
{
  static unsigned long count = 0;

  if ( pressed )
    {
      Serial.print( "Pressed " );
      Serial.println( count++ );
      pressed =  false;
      delay( 1000 ); // ignore switch bounces
    }
}
