#include <Encoder.h>

#define ENCODER_LEFT_A_PIN 2
#define ENCODER_LEFT_B_PIN A7
#define ENCODER_RIGHT_A_PIN 4
#define ENCODER_RIGHT_B_PIN A6

Encoder left_encoder( ENCODER_LEFT_A_PIN, ENCODER_LEFT_B_PIN );
Encoder right_encoder( ENCODER_RIGHT_B_PIN, ENCODER_RIGHT_A_PIN );

long left_angle  = -999;
long right_angle  = -999;

void setup()
{
  Serial.begin( 115200 );
  delay( 100 );
  Serial.println("Encoder library test.");
  delay( 1000 ); // Provide time for loader to load new code
}


void loop()
{
  long new_left_angle = left_encoder.read();
  long new_right_angle = right_encoder.read();
  if ( new_left_angle != left_angle || new_right_angle != right_angle )
    {
      left_angle = new_left_angle;
      right_angle = new_right_angle;
      Serial.print( "Left = " );
      Serial.print( left_angle );
      Serial.print(", Right = ");
      Serial.println( right_angle );
    }

  // if a character is sent from the serial monitor,
  // reset both back to zero.

  if ( Serial.available() )
    {
      Serial.read();
      Serial.println( "Reset both knobs to zero" );
      left_encoder.write(0);
      right_encoder.write(0);
    }
}
